/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/sbefw/core/sbeirq.H $                                     */
/*                                                                        */
/* OpenPOWER sbe Project                                                  */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2015,2018                        */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/*
 * $file: ppe/sbe/sbefw/sbeirq.H
 *
 * @brief This file contains the SBE PPE Interrupt Request numbers
 */

#ifndef _SBE_IRQ_H
#define _SBE_IRQ_H

/**
 * @brief SBE PPE IRQ numbers
 *
 */

#define SBE_IRQ_START0   0       /* SBE Start Vector 0 */
#define SBE_IRQ_START1   1       /* SBE Start Vector 1 */
#define SBE_IRQ_INTR0    2       /* SBE Interrupt S0 */
#define SBE_IRQ_INTR1    3       /* SBE Interrupt S1 */
#define SBE_IRQ_DRTM_REQ 4       /* DRTM late launch request */
#define SBE_IRQ_SBEFIFO_RESET 5  /* FIFO - Reset request from SE */
#define SBE_IRQ_SBEFIFO_DATA  6  /* FIFO - Incoming Data Available */
#define SBE_IRQ_HOST_PSU_INTR 7  /* PSU  - Incoming Data Available */


#define SBE_IRQ_RESERVED_8  8
#define SBE_IRQ_RESERVED_9  9

#define SBE_IRQ_RESERVED_10 10
#define SBE_IRQ_RESERVED_11 11
#define SBE_IRQ_RESERVED_12 12
#define SBE_IRQ_RESERVED_13 13
#define SBE_IRQ_RESERVED_14 14
#define SBE_IRQ_RESERVED_15 15
#define SBE_IRQ_RESERVED_16 16
#define SBE_IRQ_RESERVED_17 17
#define SBE_IRQ_RESERVED_18 18
#define SBE_IRQ_RESERVED_19 19
#define SBE_IRQ_RESERVED_20 20
#define SBE_IRQ_RESERVED_21 21
#define SBE_IRQ_RESERVED_22 22
#define SBE_IRQ_RESERVED_23 23
#define SBE_IRQ_RESERVED_24 24
#define SBE_IRQ_RESERVED_25 25
#define SBE_IRQ_RESERVED_26 26
#define SBE_IRQ_RESERVED_27 27
#define SBE_IRQ_RESERVED_28 28
#define SBE_IRQ_RESERVED_29 29
#define SBE_IRQ_RESERVED_30 30
#define SBE_IRQ_RESERVED_31 31
#define SBE_IRQ_RESERVED_32 32
#define SBE_IRQ_RESERVED_33 33
#define SBE_IRQ_RESERVED_34 34
#define SBE_IRQ_RESERVED_35 35
#define SBE_IRQ_RESERVED_36 36
#define SBE_IRQ_RESERVED_37 37
#define SBE_IRQ_RESERVED_38 38
#define SBE_IRQ_RESERVED_39 39
#define SBE_IRQ_RESERVED_40 40
#define SBE_IRQ_RESERVED_41 41
#define SBE_IRQ_RESERVED_42 42
#define SBE_IRQ_RESERVED_43 43
#define SBE_IRQ_RESERVED_44 44
#define SBE_IRQ_RESERVED_45 45
#define SBE_IRQ_RESERVED_46 46
#define SBE_IRQ_RESERVED_47 47
#define SBE_IRQ_RESERVED_48 48
#define SBE_IRQ_RESERVED_49 49
#define SBE_IRQ_RESERVED_50 50
#define SBE_IRQ_RESERVED_51 51
#define SBE_IRQ_RESERVED_52 52
#define SBE_IRQ_RESERVED_53 53
#define SBE_IRQ_RESERVED_54 54
#define SBE_IRQ_RESERVED_55 55
#define SBE_IRQ_RESERVED_56 56
#define SBE_IRQ_RESERVED_57 57
#define SBE_IRQ_RESERVED_58 58
#define SBE_IRQ_RESERVED_59 59
#define SBE_IRQ_RESERVED_60 60
#define SBE_IRQ_RESERVED_61 61
#define SBE_IRQ_RESERVED_62 62
#define SBE_IRQ_RESERVED_63 63

#define SBE_MACHINE_CHECK_HANDLER \
    b __sbe_machine_check_handler

#define SBE_INTERRUPT_REGISTER_SAVEOFF \
    bl __sbe_register_saveoff

#endif  //_SBE_IRQ_H
